package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesAssemblyNosortCfgService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesAssemblyNosortCfg;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Slf4j
public class MesAssemblyNosortCfgService extends BaseMesService<MesAssemblyNosortCfg> implements IMesAssemblyNosortCfgService {

    protected void setPackQueryBean(MesAssemblyNosortCfg bean, DdlPackBean packBean) {
        DdlPreparedPack.getNumEqualPack(bean.getPid(), "pid", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getAssemblyPartNo(), "assemblyPartNo", packBean);
    }
    @Override
    public void validateImport(List<MesAssemblyNosortCfg> beanList) {

        for (MesAssemblyNosortCfg item : beanList) {
            // 数据校验
            ValidatorBean.checkNotNull(item.getPid(), "非排序加工规则ID");
            ValidatorBean.checkNotNull(item.getAssemblyPartNo(), "原料零件号不能为空");

        }
    }
}
