package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesPartProdGroupDetailService;
import cn.estsh.i3plus.platform.common.exception.ImppExceptionEnum;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesPartProdGroup;
import cn.estsh.i3plus.pojo.mes.bean.MesPartProdGroupDetail;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Slf4j
public class MesPartProdGroupDetailService extends BaseMesService<MesPartProdGroupDetail> implements IMesPartProdGroupDetailService {



    protected void setPackQueryBean(MesPartProdGroupDetail bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getPartProdGroupCode(), "partProdGroupCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPartNo(), "partNo", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getProductPartNo(), "productPartNo", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getWorkCellCode(), "workCellCode", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getCustPartNo(), "custPartNo", packBean);


    }
    @Override
    public void validateImport(List<MesPartProdGroupDetail> beanList) {

        for (MesPartProdGroupDetail item : beanList) {
            // 数据校验
            ValidatorBean.checkNotNull(item.getPartProdGroupCode(), "零件生产组代码不能为空");
            ValidatorBean.checkNotNull(item.getPartNo(), "零件号不能为空");
            ValidatorBean.checkNotNull(item.getWorkCellCode(), "工位代码不能为空");
            ValidatorBean.checkNotNull(item.getCustPartNo(), "客户零件号不能为空");


            DdlPackBean packBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
            DdlPreparedPack.getStringEqualPack(item.getPartProdGroupCode(), "partProdGroupCode", packBean);
            DdlPreparedPack.getStringLikerPack(item.getPartNo(), "partNo", packBean);
            DdlPreparedPack.getStringEqualPack(item.getWorkCellCode(), "workCellCode", packBean);
            DdlPreparedPack.getStringEqualPack(item.getCustPartNo(), "custPartNo", packBean);
            boolean flg = baseRDao.isExitByHql(packBean);
            if (flg) {
                throw ImppExceptionBuilder.newInstance()
                        .setSystemID(CommonEnumUtil.SOFT_TYPE.MES.getCode())
                        .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
                        .setErrorDetail("【%s】零件生产组代码已经存在，请检查数据", item.getPartProdGroupCode())
                        .build();
            }
        }
    }

}
